/***
*** Interface: ngspice 1.0.0.0
 *** created by: admsXml-2.3.7 ***/


#include "ngspice/ngspice.h"
#include "ngspice/cktdefs.h"
#include "bsimcmgdefs.h"
#include "ngspice/sperror.h"
#include "ngspice/suffix.h"

int bsimcmgtrunc(GENmodel *inModel, CKTcircuit *ckt, double *timeStep)
{
  bsimcmgmodel *model = (bsimcmgmodel*)inModel;
  bsimcmginstance *here;

#ifdef STEPDEBUG
    double debugtemp;
#endif /* STEPDEBUG */  
  
  for ( ; model != NULL; model = bsimcmgnextModel(model) )
  {
    /* loop through all the instances of the model */
    for (here = bsimcmginstances(model); here != NULL ; here = bsimcmgnextInstance(here))
    {
#ifdef STEPDEBUG
            debugtemp = *timeStep;
#endif /* STEPDEBUG */   
 
            CKTterr(here->state_t_GND, ckt, timeStep);
            CKTterr(here->state_ge_d, ckt, timeStep);
            CKTterr(here->state_ge_s, ckt, timeStep);
            CKTterr(here->state_d_s, ckt, timeStep);
            CKTterr(here->state_e_ge, ckt, timeStep);
            CKTterr(here->state_e_di, ckt, timeStep);
            CKTterr(here->state_e_si, ckt, timeStep);
            CKTterr(here->state_ge_di, ckt, timeStep);
            CKTterr(here->state_ge_si, ckt, timeStep);
            CKTterr(here->state_di_si, ckt, timeStep);
    
 
#ifdef STEPDEBUG
            if(debugtemp != *timeStep)
	    {  printf("device %s reduces step from %g to %g\n",
                       here->bsimcmgname,debugtemp,*timeStep);
            }
#endif /* STEPDEBUG */
   
    } /* End of Instance */
  } /* End of Model */
  return(OK);
}
