/*
 * bsimcmg.analogfunction.h - analog function header
 *
 * This is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 */

#ifndef __bsimcmg_ANALOGFUNCTION_H__
#define __bsimcmg_ANALOGFUNCTION_H__


/*
 * analog function: lexp
 */
double bsimcmg_lexp (
  double x
  );
double bsimcmg_d_lexp (
  double x,
  double d_x
  );

/*
 * analog function: lln
 */
double bsimcmg_lln (
  double x
  );
double bsimcmg_d_lln (
  double x,
  double d_x
  );

/*
 * analog function: hypsmooth
 */
double bsimcmg_hypsmooth (
  double x,
  double c
  );
double bsimcmg_d_hypsmooth (
  double x,
  double c,
  double d_x,
  double d_c
  );

/*
 * analog function: hypmax
 */
double bsimcmg_hypmax (
  double x,
  double xmin,
  double c
  );
double bsimcmg_d_hypmax (
  double x,
  double xmin,
  double c,
  double d_x,
  double d_xmin,
  double d_c
  );

/*
 * analog function: Tempdep
 */
double bsimcmg_Tempdep (
  double PARAML,
  double PARAMT,
  double DELTEMP,
  double TEMPMOD
  );
double bsimcmg_d_Tempdep (
  double PARAML,
  double PARAMT,
  double DELTEMP,
  double TEMPMOD,
  double d_PARAML,
  double d_PARAMT,
  double d_DELTEMP,
  double d_TEMPMOD
  );

#endif /* __bsimcmg_ANALOGFUNCTION_H__ */
