/***
*** Interface: ngspice 1.0.0.0
 *** created by: admsXml-2.3.7 ***/


#include "ngspice/ngspice.h"
#include "ngspice/cktdefs.h"
#include "ngspice/smpdefs.h"
#include "r2_cmcdefs.h"
#include "ngspice/const.h"
#include "ngspice/sperror.h"
#include "ngspice/ifsim.h"
#include "ngspice/suffix.h"

#define _STATIC
#define _DYNAMIC

int r2_cmctemp(GENmodel *inModel, CKTcircuit *ckt)
{
  r2_cmcmodel *model = (r2_cmcmodel*)inModel;
  r2_cmcinstance *here;
  NG_IGNOREABLE(ckt);
  for ( ; model != NULL; model = r2_cmcnextModel(model) )
  {

    /* loop through all the instances of the model */
    for (here = r2_cmcinstances(model); here != NULL ; here = r2_cmcnextInstance(here))
    {
double tcr=0.0/0.0;
int GFORM;
double tc2e=0.0/0.0;
double tc1e=0.0/0.0;
double xleff=0.0/0.0;
double delt=0.0/0.0;
double tdevC=0.0/0.0;
double tiniK=0.0/0.0;
double lFactor=0.0/0.0;
double rthrR2=0.0/0.0;
double shrinkL=0.0/0.0;
double scaleFac=0.0/0.0;
{
if
((model->level!=1002))
{
{
fprintf(stdout,"ERROR: r2 model called with incorrect level parameter");
fprintf(stdout,"\n");
controlled_exit(1);
}
}
scaleFac=model->scale;
EXIT_IF_ISNAN(scaleFac)
shrinkL=(1.0-(0.01*model->shrink));
EXIT_IF_ISNAN(shrinkL)
#if defined(_DYNAMIC)
rthrR2=model->rthresh;
EXIT_IF_ISNAN(rthrR2)
#endif /*_DYNAMIC*/
lFactor=((shrinkL*scaleFac)*1.0e6);
EXIT_IF_ISNAN(lFactor)
tiniK=(2.73150000e+02+model->tnom);
EXIT_IF_ISNAN(tiniK)
tdevC=((_circuit_temp+here->trise)-2.73150000e+02);
EXIT_IF_ISNAN(tdevC)
if
((tdevC<model->tmin))
{
fprintf(stdout,"WARNING: ambient temperature is lower than allowed minimum");
fprintf(stdout,"\n");
;
}
if
((tdevC>model->tmax))
{
fprintf(stdout,"WARNING: ambient temperature is higher than allowed maximum");
fprintf(stdout,"\n");
;
}
if
((tdevC<(model->tminclip+1.0)))
{
{
double __exp_0=0.0;
_f_exp(__exp_0,(((tdevC-model->tminclip)-1.0)))
EXIT_IF_ISNAN(__exp_0)
tdevC=(model->tminclip+__exp_0);
EXIT_IF_ISNAN(tdevC)
}
}
else
{
if
((tdevC>(model->tmaxclip-1.0)))
{
{
double __exp_0=0.0;
_f_exp(__exp_0,(((model->tmaxclip-tdevC)-1.0)))
EXIT_IF_ISNAN(__exp_0)
tdevC=(model->tmaxclip-__exp_0);
EXIT_IF_ISNAN(tdevC)
}
}
else
{
tdevC=tdevC;
EXIT_IF_ISNAN(tdevC)
}
}
;
here->tdevK=(tdevC+2.73150000e+02);
EXIT_IF_ISNAN(here->tdevK)
delt=(here->tdevK-tiniK);
EXIT_IF_ISNAN(delt)
here->kfn_t=((1+(delt*model->tc1kfn))*model->kfn);
EXIT_IF_ISNAN(here->kfn_t)
if
((here->kfn_t<0.0))
{
here->kfn_t=0.0;
EXIT_IF_ISNAN(here->kfn_t)
}
if
((here->c1&&here->c2))
{
xleff=model->xl;
EXIT_IF_ISNAN(xleff)
}
else
{
if
((here->c1||here->c2))
{
xleff=(model->xl*0.5);
EXIT_IF_ISNAN(xleff)
}
else
{
xleff=0.0;
EXIT_IF_ISNAN(xleff)
}
}
if
(((here->l_Given&&here->r_Given)&&(!here->w_Given)))
{
if
(((here->r==0.0)||(here->l==0.0)))
{
here->l_um=0.0;
EXIT_IF_ISNAN(here->l_um)
here->leff_um=0.0;
EXIT_IF_ISNAN(here->leff_um)
here->w_um=(here->w*lFactor);
EXIT_IF_ISNAN(here->w_um)
here->weff_um=(here->w_um+model->xw);
EXIT_IF_ISNAN(here->weff_um)
here->r0=0.0;
EXIT_IF_ISNAN(here->r0)
here->g0=1.0e99;
EXIT_IF_ISNAN(here->g0)
}
else
{
here->l_um=(here->l*lFactor);
EXIT_IF_ISNAN(here->l_um)
here->leff_um=(here->l_um+xleff);
EXIT_IF_ISNAN(here->leff_um)
if
((here->leff_um<0.0))
{
{
fprintf(stdout,"ERROR: calculated effective r2_cmc resistor length is < 0.0");
fprintf(stdout,"\n");
controlled_exit(1);
}
}
if
((here->leff_um>0.0))
{
here->weff_um=((model->rsh/here->r)*here->leff_um);
EXIT_IF_ISNAN(here->weff_um)
here->w_um=(here->weff_um-model->xw);
EXIT_IF_ISNAN(here->w_um)
if
((here->w_um<=0.0))
{
{
fprintf(stdout,"ERROR: calculated design r2_cmc resistor width is <= 0.0");
fprintf(stdout,"\n");
controlled_exit(1);
}
}
here->r0=here->r;
EXIT_IF_ISNAN(here->r0)
here->g0=(1.0/here->r0);
EXIT_IF_ISNAN(here->g0)
}
else
{
here->w_um=(here->w*lFactor);
EXIT_IF_ISNAN(here->w_um)
here->weff_um=(here->w_um+model->xw);
EXIT_IF_ISNAN(here->weff_um)
here->r0=0.0;
EXIT_IF_ISNAN(here->r0)
here->g0=1.0e99;
EXIT_IF_ISNAN(here->g0)
}
}
}
else
{
if
((here->r_Given&&(!here->l_Given)))
{
if
((here->r==0.0))
{
here->l_um=0.0;
EXIT_IF_ISNAN(here->l_um)
here->leff_um=0.0;
EXIT_IF_ISNAN(here->leff_um)
here->w_um=(here->w*lFactor);
EXIT_IF_ISNAN(here->w_um)
here->weff_um=(here->w_um+model->xw);
EXIT_IF_ISNAN(here->weff_um)
here->r0=0.0;
EXIT_IF_ISNAN(here->r0)
here->g0=1.0e99;
EXIT_IF_ISNAN(here->g0)
}
else
{
if
((here->w==0.0))
{
here->w_um=0.0;
EXIT_IF_ISNAN(here->w_um)
here->weff_um=0.0;
EXIT_IF_ISNAN(here->weff_um)
here->l_um=(here->l*lFactor);
EXIT_IF_ISNAN(here->l_um)
here->leff_um=(here->l_um+xleff);
EXIT_IF_ISNAN(here->leff_um)
here->r0=1.0e99;
EXIT_IF_ISNAN(here->r0)
here->g0=0.0;
EXIT_IF_ISNAN(here->g0)
}
else
{
here->w_um=(here->w*lFactor);
EXIT_IF_ISNAN(here->w_um)
here->weff_um=(here->w_um+model->xw);
EXIT_IF_ISNAN(here->weff_um)
if
((here->weff_um<0.0))
{
{
fprintf(stdout,"ERROR: calculated effective r2_cmc resistor width is < 0.0");
fprintf(stdout,"\n");
controlled_exit(1);
}
}
if
((here->weff_um>0.0))
{
here->leff_um=((here->r/model->rsh)*here->weff_um);
EXIT_IF_ISNAN(here->leff_um)
here->l_um=(here->leff_um-xleff);
EXIT_IF_ISNAN(here->l_um)
if
((here->l_um<=0.0))
{
{
fprintf(stdout,"ERROR: calculated design r2_cmc resistor length is <= 0.0");
fprintf(stdout,"\n");
controlled_exit(1);
}
}
here->r0=here->r;
EXIT_IF_ISNAN(here->r0)
here->g0=(1.0/here->r0);
EXIT_IF_ISNAN(here->g0)
}
else
{
here->l_um=(here->l*lFactor);
EXIT_IF_ISNAN(here->l_um)
here->leff_um=(here->l_um+xleff);
EXIT_IF_ISNAN(here->leff_um)
here->r0=1.0e99;
EXIT_IF_ISNAN(here->r0)
here->g0=0.0;
EXIT_IF_ISNAN(here->g0)
}
}
}
}
else
{
if
((here->w==0.0))
{
here->w_um=0.0;
EXIT_IF_ISNAN(here->w_um)
here->weff_um=0.0;
EXIT_IF_ISNAN(here->weff_um)
here->l_um=(here->l*lFactor);
EXIT_IF_ISNAN(here->l_um)
here->leff_um=(here->l_um+xleff);
EXIT_IF_ISNAN(here->leff_um)
here->r0=1.0e99;
EXIT_IF_ISNAN(here->r0)
here->g0=0.0;
EXIT_IF_ISNAN(here->g0)
}
else
{
if
((here->l==0.0))
{
here->l_um=0.0;
EXIT_IF_ISNAN(here->l_um)
here->leff_um=0.0;
EXIT_IF_ISNAN(here->leff_um)
here->w_um=(here->w*lFactor);
EXIT_IF_ISNAN(here->w_um)
here->weff_um=(here->w_um+model->xw);
EXIT_IF_ISNAN(here->weff_um)
here->r0=0.0;
EXIT_IF_ISNAN(here->r0)
here->g0=1.0e99;
EXIT_IF_ISNAN(here->g0)
}
else
{
here->w_um=(here->w*lFactor);
EXIT_IF_ISNAN(here->w_um)
here->weff_um=(here->w_um+model->xw);
EXIT_IF_ISNAN(here->weff_um)
if
((here->weff_um<0.0))
{
{
fprintf(stdout,"ERROR: calculated effective r2_cmc resistor width is < 0.0");
fprintf(stdout,"\n");
controlled_exit(1);
}
}
here->l_um=(here->l*lFactor);
EXIT_IF_ISNAN(here->l_um)
here->leff_um=(here->l_um+xleff);
EXIT_IF_ISNAN(here->leff_um)
if
((here->weff_um>0.0))
{
if
((here->leff_um<0.0))
{
{
fprintf(stdout,"ERROR: calculated effective r2_cmc resistor length is < 0.0");
fprintf(stdout,"\n");
controlled_exit(1);
}
}
if
((here->leff_um>0.0))
{
here->r0=(model->rsh*(here->leff_um/here->weff_um));
EXIT_IF_ISNAN(here->r0)
here->g0=(1.0/here->r0);
EXIT_IF_ISNAN(here->g0)
}
else
{
here->r0=0.0;
EXIT_IF_ISNAN(here->r0)
here->g0=1.0e99;
EXIT_IF_ISNAN(here->g0)
}
}
else
{
here->r0=1.0e99;
EXIT_IF_ISNAN(here->r0)
here->g0=0.0;
EXIT_IF_ISNAN(here->g0)
}
}
}
}
}
if
((here->l_um<model->lmin))
{
fprintf(stdout,"WARNING: drawn length is smaller than allowed minimum");
fprintf(stdout,"\n");
;
}
if
((here->l_um>model->lmax))
{
fprintf(stdout,"WARNING: drawn length is greater than allowed maximum");
fprintf(stdout,"\n");
;
}
if
((here->w_um<model->wmin))
{
fprintf(stdout,"WARNING: drawn width is smaller than allowed minimum");
fprintf(stdout,"\n");
;
}
if
((here->w_um>model->wmax))
{
fprintf(stdout,"WARNING: drawn width is greater than allowed maximum");
fprintf(stdout,"\n");
;
}
if
(model->sw_efgeo)
{
here->l_umForE=(here->leff_um+model->dxle);
EXIT_IF_ISNAN(here->l_umForE)
}
else
{
here->l_umForE=(here->l_um+model->dxle);
EXIT_IF_ISNAN(here->l_umForE)
}
if
((((here->l_umForE<=0.0)&&(here->r0>0.0))&&((model->p2>0.0)||(model->p3>0.0))))
{
{
fprintf(stdout,"ERROR: calculated effective r2_cmc resistor length for E calculation is < 0.0");
fprintf(stdout,"\n");
controlled_exit(1);
}
}
tc1e=model->tc1;
EXIT_IF_ISNAN(tc1e)
tc2e=model->tc2;
EXIT_IF_ISNAN(tc2e)
if
((here->leff_um>0.0))
{
if
((here->c1&&here->c2))
{
tc1e=(tc1e+(model->tc1l/here->leff_um));
EXIT_IF_ISNAN(tc1e)
tc2e=(tc2e+(model->tc2l/here->leff_um));
EXIT_IF_ISNAN(tc2e)
}
else
{
if
((here->c1||here->c2))
{
tc1e=(tc1e+((0.5*model->tc1l)/here->leff_um));
EXIT_IF_ISNAN(tc1e)
tc2e=(tc2e+((0.5*model->tc2l)/here->leff_um));
EXIT_IF_ISNAN(tc2e)
}
}
}
if
((here->weff_um>0.0))
{
tc1e=(tc1e+(model->tc1w/here->weff_um));
EXIT_IF_ISNAN(tc1e)
tc2e=(tc2e+(model->tc2w/here->weff_um));
EXIT_IF_ISNAN(tc2e)
}
#ifdef _DYNAMIC /*<dynamic_ifthenelse>*/
if
((here->r0>(rthrR2/model->m)))
{
#if defined(_DYNAMIC)
GFORM=1;
EXIT_IF_ISNAN(GFORM)
#endif /*_DYNAMIC*/
}
else
{
#if defined(_DYNAMIC)
GFORM=0;
EXIT_IF_ISNAN(GFORM)
#endif /*_DYNAMIC*/
}
#endif /*</dynamic_ifthenelse>*/
tcr=(1+(delt*(tc1e+(delt*tc2e))));
EXIT_IF_ISNAN(tcr)
if
((tcr<(0.01+0.1)))
{
{
double __exp_0=0.0;
_f_exp(__exp_0,(((10.0*(tcr-0.01))-1.0)))
EXIT_IF_ISNAN(__exp_0)
tcr=(0.01+(0.1*__exp_0));
EXIT_IF_ISNAN(tcr)
}
}
else
{
tcr=tcr;
EXIT_IF_ISNAN(tcr)
}
here->r0_t=(here->r0*tcr);
EXIT_IF_ISNAN(here->r0_t)
here->g0_t=(here->g0/tcr);
EXIT_IF_ISNAN(here->g0_t)
}

    } /* End of MOSFET Instance */
  } /* End of Model Instance */
  return(OK);
}
